unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart, Series,
  StdCtrls, Grids, TeeChartGrid, TeCanvas, TeeStore, TeeComma, TeeEditPro;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Chart2: TChart;
    Button1: TButton;
    ChartGrid1: TChartGrid;
    ChartGrid2: TChartGrid;
    ComboFlat1: TComboFlat;
    Button2: TButton;
    TeeCommander1: TTeeCommander;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Chart2ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure ComboFlat1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ChartGrid1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }

    Master : TChartSeries;

    procedure SelectDetail(ValueIndex:Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Create Master Series

  Master:=Chart1.AddSeries(TBarSeries);

  Master.Name:='Sample';
  Master.ColorEachPoint:=True;

  // Fill Master data

  Master.Detail.Aggregate:=daSum; // <-- default

  Master.BeginUpdate;   // optional, for speed

  Master.Add([21,14,59,8], 'Cars');
  Master.Add([5,10,20,7],  'Lamps');
  Master.Add([17,20,6,12], 'Tables');

  Master.Detail[0].Labels[1]:='Ford';

  Master.Detail[2].Labels[2]:='Wood';

  Master.EndUpdate;

  ChartGrid2.ShowLabels:=False;
end;

procedure TForm1.SelectDetail(ValueIndex:Integer);
begin
  Chart2.RemoveAllSeries;

  if Master.Detail.Count>ValueIndex then  // <-- just a safety check
  begin
    Master.Detail[ValueIndex].Color:=Master.ValueColor[ValueIndex];

    Master.Detail[ValueIndex].ParentChart:=Chart2;

    Chart2.Title.Caption:=Master.Detail[ValueIndex].Title;
  end;
end;

procedure TForm1.Chart1ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SelectDetail(ValueIndex);
  ChartGrid1.Row:=ValueIndex+2;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Master.Delete(1);
end;

procedure TForm1.Chart2ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ChartGrid2.Row:=ValueIndex+2;
end;

procedure TForm1.ComboFlat1Change(Sender: TObject);
begin
  Master.Detail.Aggregate:=TDetailAggregate(ComboFlat1.ItemIndex);
end;

procedure TForm1.Button2Click(Sender: TObject);
var tmp : TMemoryStream;
begin
  tmp:=TMemoryStream.Create;
  try
    SaveChartToStream(Chart1,tmp);

    tmp.Position:=0;

    Chart1.FreeAllSeries;

    LoadChartFromStream(Chart1,tmp);
  finally
    tmp.Free;
  end;
end;

procedure TForm1.ChartGrid1Click(Sender: TObject);
var tmp: Integer;
begin
  if Assigned(Master) then
  begin
    tmp:=ChartGrid1.Row-2;

    if (tmp>=0) and (tmp<Master.Count) then
        SelectDetail(tmp);
  end;
end;

procedure ToggleDetails(const ASeries:TChartSeries; Master:Boolean);
var t : Integer;
begin
  ASeries.Visible:=Master;

  for t:=0 to ASeries.Detail.Count-1 do
      if Master then
         ASeries.Detail[t].ParentChart:=nil
      else
         ASeries.Detail[t].ParentChart:=ASeries.ParentChart;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
var t : Integer;
begin
  ToggleDetails(Master,RadioGroup1.ItemIndex=0);

  if Master.Visible then
     (Master as TCustomBarSeries).MultiBar:=mbSide
  else
     (Master.Detail[0] as TCustomBarSeries).MultiBar:=mbSelfStack;

  for t:=0 to Master.Detail.Count-1 do
      Master.Detail[t].ColorEachPoint:=True;

end;

end.
